#include <packet32.h>
#include <ntddndis.h>
#include <stdio.h>
#include <stdlib.h>


#define EXIT_SUCCESS    0
#define EXIT_FAILURE    1
/* Ethernet header */
#define	ETH_TYPE_ARP     0x0806  /* Ether type ARP            */
#define ETH_ADD_LEN      6       /* Ethernet address length   */
#define ETH_PADDING_ARP  18      /* 18 bytes ethernet padding */

/* ARP header */
#define ARP_HW_ETH         1     /* Hardware type 10Mb Ethernet */
#define ARP_PRO_IP         0x800 /* ARP Protocol IP             */
#define ARP_ETH_ADD_SPACE  6     /* Ethernet address length     */
#define ARP_IP_ADD_SPACE   4     /* IP address length           */
#define ARP_OP_REQUEST     1     /* ARP request                 */
#define ARP_OP_REPLY       2     /* ARP reply                   */
#define ADAPTER_NAMES_SIZE 1024
#define MAX_ADAPTER_NUM 10
#define PING_TIMEOUT 1500
#define SHOWSTAT(X) (MainScr->lbStatus->Items->Add(X))
#define REPORT(X) (MainScr->lbReport->Items->Add(X))

typedef struct _TArpPacket
{
  /* Ethernet header */
  unsigned char      eth_dst_addr[ETH_ADD_LEN]; /* Destination ethernet address	        */
  unsigned char      eth_src_addr[ETH_ADD_LEN]; /* Source ethernet address              */
  unsigned short int eth_type;                  /* EtherType                            */

  /* ARP header */
  unsigned short int ar_hrd;                    /* Hardware address space               */
  unsigned short int ar_pro;                    /* Protocol address space               */
  unsigned char      ar_hln;                    /* byte length of each hardware address */
  unsigned char      ar_pln;                    /* byte length of each protocol address */
  unsigned short int ar_op;                     /* ARP opcode                           */
  unsigned char      ar_sha[ARP_ETH_ADD_SPACE]; /* Sender hardware address              */
  unsigned char      ar_spa[ARP_IP_ADD_SPACE];  /* Sender protocol address              */
  unsigned char      ar_tha[ARP_ETH_ADD_SPACE]; /* Target hardware address              */
  unsigned char      ar_tpa[ARP_IP_ADD_SPACE];  /* Target protocol address              */

  /* Ethernet padding */
  unsigned char      eth_pad[ETH_PADDING_ARP];  /* Ethernet padding                     */
}TArpPacket , *PArpPacket;
typedef struct _TArpFuncParam
{
        LPADAPTER lpAdapter;
        char  AdapterList[MAX_ADAPTER_NUM][ADAPTER_NAMES_SIZE];
        int   SelectedAdapter;
        int   delay;
        int   numPacks;
        unsigned short int ar_hw;
        unsigned char srcIPAdd[4],srcMAC[6];
}TArpFuncParam,*PArpFuncParam;

/* Prototype */
void GetLocalMAC(LPADAPTER, unsigned char *);
int  CheckPROMode(LPADAPTER , unsigned char *, unsigned char * );
int  GetARPReply(LPPACKET, unsigned char *, unsigned char *);
int  BuildARPPacket(PArpPacket, unsigned char *, unsigned char *, int,
			   unsigned char *, unsigned char *, unsigned char *, 
			   unsigned char *,unsigned short int);
int  OpenAdapter(LPADAPTER *);
int Ping(HANDLE*,unsigned long);
void CloseAdapter(LPADAPTER);
