//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "frmMain.h"
#include "ArpBuild.h"
#include "frmMainScr.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma resource "*.dfm"
#pragma comment( lib, "packet.lib" )
TfrmSetup *frmSetup;
/***********************************************************************************/

int   InterfaceSet = 0;
extern TArpFuncParam wParams;
extern AnsiString msgStatus;

/************************************************************************************/

//---------------------------------------------------------------------------
__fastcall TfrmSetup::TfrmSetup(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

int TfrmSetup::Load_Interface_List()
{
                    /* UNICODE strings for WINNT */
  WCHAR  AdapterNameU[ADAPTER_NAMES_SIZE];
  WCHAR  *TmpAdapterU;
  WCHAR  *AnotherTmpAdapterU;
  int   AdapterNum;
  int   i = 0;

  ULONG AdapterLength = ADAPTER_NAMES_SIZE;
  DWORD Version;
  DWORD WindowsMajorVersion;

  /* Get operating system version */
  Version = GetVersion();
  WindowsMajorVersion = (DWORD)(LOBYTE(LOWORD(Version)));

  /* Get adapter names */
  if(!(Version >= 0x80000000 && WindowsMajorVersion >= 4)) {
    // Windows NT
    if(PacketGetAdapterNames((PTSTR)AdapterNameU, &AdapterLength) == FALSE)
    {
      msgStatus = "Error getting adapter names....";
      SHOWSTAT(msgStatus);
      return(EXIT_FAILURE);
    }

    TmpAdapterU = AdapterNameU;
    AnotherTmpAdapterU = AdapterNameU;

    while((*TmpAdapterU != '\0') || (*(TmpAdapterU - 1) != '\0')) {
      if(*TmpAdapterU == '\0') {
        memcpy(wParams.AdapterList[i], AnotherTmpAdapterU, (TmpAdapterU - AnotherTmpAdapterU ) * 2);
		wParams.AdapterList[i][(TmpAdapterU - AnotherTmpAdapterU ) * 2] = '\0';
        AnotherTmpAdapterU = TmpAdapterU + 1;
        i++;
      }

      TmpAdapterU ++;
    }
    AnsiString tmp;
    AdapterNum = i;
    for(i = 0 ; i < AdapterNum ; i++)
    {
     tmp.sprintf("%d - %S", i + 1, wParams.AdapterList[i]);
     ComboBox1->Items->Add(tmp);
    }
  }
  else
  {
        msgStatus = "Error : This program works under Windows NTx.";
        SHOWSTAT(msgStatus);
        return(EXIT_FAILURE);
  }
  return(EXIT_SUCCESS);
}

//---------------------------------------------------------------------------

void __fastcall TfrmSetup::FormCreate(TObject *Sender)
{
 if(Load_Interface_List() != EXIT_SUCCESS)
 {
      msgStatus = "Error : Couldn't load interface list..";
      SHOWSTAT(msgStatus);
 }
 cmbHW->ItemIndex = 0;

}
//---------------------------------------------------------------------------
void __fastcall TfrmSetup::Button1Click(TObject *Sender)
{
        wParams.SelectedAdapter = ComboBox1->ItemIndex;
        wParams.ar_hw = cmbHW->ItemIndex + 1;
        wParams.delay = StrToInt(edtDelay->Text);
        wParams.numPacks = StrToInt(edtNumPackets->Text);
        sscanf(srcIP->Text.c_str(), "%d.%d.%d.%d",
	       &(wParams.srcIPAdd[0]), &(wParams.srcIPAdd[1]), &(wParams.srcIPAdd[2]), &(wParams.srcIPAdd[3]));
        sscanf(srcMac->Text.c_str(),"%02X-%02X-%02X-%02X-%02X-%02X",
                                &(wParams.srcMAC[0]),&(wParams.srcMAC[1]),&(wParams.srcMAC[2]),&(wParams.srcMAC[3]),&(wParams.srcMAC[4]),
                                                &(wParams.srcMAC[5]));
        frmSetup->Close();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TfrmSetup::ComboBox1Change(TObject *Sender)
{       AnsiString tmp;
        wParams.SelectedAdapter = ComboBox1->ItemIndex;
        OpenAdapter(&(wParams.lpAdapter));
        GetLocalMAC(wParams.lpAdapter,wParams.srcMAC);
        CloseAdapter(wParams.lpAdapter);
        tmp.sprintf("%02X-%02X-%02X-%02X-%02X-%02X",wParams.srcMAC[0],wParams.srcMAC[1],wParams.srcMAC[2],
                                                     wParams.srcMAC[3],wParams.srcMAC[4],wParams.srcMAC[5]);
        srcMac->Text = tmp;
        InterfaceSet = 1;
}
//---------------------------------------------------------------------------


