//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "frmPref.h"
#include "frmMainScr.h"
#include "icmp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TfrmPreferences *frmPreferences;
TProOptions optPro;
extern TStringList *IPList;
//---------------------------------------------------------------------------
__fastcall TfrmPreferences::TfrmPreferences(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmPreferences::chkExtractClick(TObject *Sender)
{
        if(chkExtract->Checked == 1)
        {
                edtFrom->Enabled = false;
                edtTo->Enabled = false;
                edtTo->Color = clMenu;
                edtFrom->Color = clMenu;
                btnExtract->Enabled = false;
                btnFile->Enabled = true;
                btnClr1->Enabled = false;
                btnClr2->Enabled = false;
        }
        else{
                edtFrom->Enabled = true;
                edtTo->Enabled = true;
                edtTo->Color = clWhite;
                edtFrom->Color = clWhite;
                btnExtract->Enabled = true;
                btnFile->Enabled = false;
                btnClr1->Enabled = true;
                btnClr2->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::chkSMTPClick(TObject *Sender)
{
        if(chkSMTP->Checked ==1)
        {
                grpSMTP->Enabled = true;
                edtUsername->Color = clWhite;
                edtPassword->Color = clWhite;
                edtSMTPServer->Color = clWhite;
                edtMail->Color = clWhite;
        }else
        {
               edtMail->Color = clMenu;
               if(chkSMS->Checked !=1)
               {
                        grpSMTP->Enabled = false;
                        edtUsername->Color = clMenu;
                        edtPassword->Color = clMenu;
                        edtSMTPServer->Color = clMenu;
                }
        }

}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::chkFileClick(TObject *Sender)
{
        if(chkFile->Checked ==1)
        {
                grpFile->Enabled = true;
                edtLogFile->Color = clWhite;
        }else
        {
                grpFile->Enabled = false;
                edtLogFile->Color = clMenu;
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::chkSMSClick(TObject *Sender)
{
        if(chkSMS->Checked ==1)
        {
                grpSMS->Enabled = true;
                edtGateway->Color = clWhite;
                grpSMTP->Enabled = true;
                edtUsername->Color = clWhite;
                edtPassword->Color = clWhite;
                edtSMTPServer->Color = clWhite;
        }else
        {
                grpSMS->Enabled = false;
                edtGateway->Color = clMenu;
                if(chkSMTP->Checked != 1)
                {
                        grpSMTP->Enabled = false;
                        edtUsername->Color = clMenu;
                        edtPassword->Color = clMenu;
                        edtSMTPServer->Color = clMenu;
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnClearClick(TObject *Sender)
{
        lstIPList->Clear();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnExtractClick(TObject *Sender)
{

        unsigned long i , from , to;
        unsigned int j =0;
        struct in_addr addr;
        bool flg;
        AnsiString tmp;
        ICMP* icmp;
        lstIPList->Clear();
        tmp = edtFrom->Text;
        flg = chkPing->Checked;

        if((from = inet_addr((char*)tmp.c_str()))== INADDR_NONE)
        {
                Application->MessageBoxA("Invalid Starting IP","Error",MB_OK );
                return;
        }
        tmp = edtTo->Text;
        if((to = inet_addr((char*)tmp.c_str()))== INADDR_NONE)
        {
                Application->MessageBoxA("Invalid Ending IP","Error",MB_OK );
                return;
        }
        if(flg)
        {
                IPList->Clear();
                IPList->Duplicates = dupIgnore;
                icmp = new ICMP(2000,from,to,1,100);
                icmp->Ping(IPList);
                IPList->Sort();
                for(i = 0; i< IPList->Count;i++)
                {
                        lstIPList->Items->Add(IPList->Strings[i]);
                        lstIPList->Checked[i] = 1;
                }
        }
        else
        {
                for (i = ntohl(from) , j = 0; i <= ntohl(to); i++)
                {
                        if((i & 0xff) == 0 || (i & 0xff) == 255)
                                continue;
                        addr.S_un.S_addr = ntohl(i);
                        tmp.sprintf("%s",inet_ntoa(addr));
                        lstIPList->Items->Add(tmp);
                        lstIPList->Checked[j++] = 1;
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnClr1Click(TObject *Sender)
{
        edtFrom->Text = "";        
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnClr2Click(TObject *Sender)
{
        edtTo->Text = "";         
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnClr0Click(TObject *Sender)
{
        edtHost->Text = "";         
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnHostClick(TObject *Sender)
{
        AnsiString tmp;
        unsigned long host;
        tmp = edtHost->Text;
        if((host=inet_addr((char*)tmp.c_str()))==INADDR_NONE)
        {
                ShowMessage("Invalid  IP address");
                return;
        }
        lstIPList->Items->Add(tmp);
        lstIPList->Checked[lstIPList->Items->IndexOf(tmp)] = 1;
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnRemoveClick(TObject *Sender)
{
        if(lstIPList->ItemIndex !=  -1)
                lstIPList->Items->Delete(lstIPList->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::btnFileClick(TObject *Sender)
{
        int iFileHandle;
        int iFileLength;
        char *pszBuffer;
        char *IP;
        int i = 0;
        unsigned long host;
        AnsiString tmp,tmp2;

        dlgOpen->Title = "Open IP list File";
        dlgOpen->Filter = "Text files (*.txt)|*.TXT";
        if (dlgOpen->Execute())
                if (FileExists(dlgOpen->FileName))
                {
                        iFileHandle = FileOpen(dlgOpen->FileName, fmOpenRead);
                        iFileLength = FileSeek(iFileHandle,0,2);
                        FileSeek(iFileHandle,0,0);
                        pszBuffer = new char[iFileLength+1];
                        memset(pszBuffer,0,iFileLength+1);
                        FileRead(iFileHandle, pszBuffer, iFileLength);
                        FileClose(iFileHandle);
                        IP = strtok(pszBuffer,"#");
                        tmp2 = tmp.sprintf("%s",IP);
                        lstIPList->Clear();
                        if(IP)
                                if((host=inet_addr(tmp2.c_str()))!=INADDR_NONE)
                                {
                                       lstIPList->Items->Add(tmp2);
                                       lstIPList->Checked[i++]= 1;
                                }
                        while(IP)
                        {
                                IP = strtok(NULL,"#");
                                if(IP)
                                {
                                        tmp.sprintf("%s",IP);
                                        tmp2 = tmp.Trim();
                                        if((host =inet_addr(tmp2.c_str()))!=INADDR_NONE)
                                        {
                                                lstIPList->Items->Add(tmp2);
                                                lstIPList->Checked[i++]= 1;
                                        }
                                }
                        }
                        delete [] pszBuffer;
                }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::BitBtn1Click(TObject *Sender)
{
      ReadOptions();
      WriteINIFile();
      if(chkAuto->Checked)
      {
                MainScr->Timer1->Interval =optPro.optHost.iInterval*60000;
                MainScr->Timer1->Enabled = true;
      }else
                MainScr->Timer1->Enabled = false;
      frmPreferences->Close();
}
//---------------------------------------------------------------------------


void TfrmPreferences::ReadINIFIle()
{
        int iFileHandle;
        int iFileLength;
        AnsiString path,file;

        path = GetCurrentDir();
        file = path +"\\"+INIFile;
        iFileLength = sizeof(optPro);
        iFileHandle = FileOpen(file, fmOpenRead);
        FileRead(iFileHandle, &optPro,iFileLength);
        FileClose(iFileHandle);
        file = path +"\\"+ HOSTFile;
        if(FileExists(file))
                lstIPList->Items->LoadFromFile(file);
        for(int i = 0;i < lstIPList->Items->Count;i++)
                if(optPro.optHost.bitmap[i] == 1)
                        lstIPList->Checked[i] = 1;
}

void TfrmPreferences::ReadOptions()
{
    optPro.optHost.bAutostart = chkAuto->Checked;
    optPro.optHost.iInterval = StrToInt(edtFreq->Text);
    if(chkSMTP->Checked)
    {
        optPro.optAlert.bSMTP = true;
        strcpy(optPro.optAlert.smtpUser , edtUsername->Text.c_str());
        strcpy(optPro.optAlert.smtpPassword , edtPassword->Text.c_str());
        strcpy(optPro.optAlert.smtpServer , edtSMTPServer->Text.c_str());
        strcpy(optPro.optAlert.Mail , edtMail->Text.c_str());
    }
    else
    {
        optPro.optAlert.bSMTP = false;
        strcpy(optPro.optAlert.smtpUser , "\0");
        strcpy(optPro.optAlert.smtpPassword , "\0");
        strcpy(optPro.optAlert.smtpServer , "\0");
        strcpy(optPro.optAlert.Mail , "\n");
    }
    if(chkSMS->Checked)
    {
        optPro.optAlert.bSMS = true;
        if(!chkSMTP->Checked)
        {
                strcpy(optPro.optAlert.smtpUser , edtUsername->Text.c_str());
                strcpy(optPro.optAlert.smtpPassword , edtPassword->Text.c_str());
                strcpy(optPro.optAlert.smtpServer , edtSMTPServer->Text.c_str());
        }
        strcpy(optPro.optAlert.smsGateway , edtGateway->Text.c_str());
    }
    else
    {
        optPro.optAlert.bSMS = false;
        strcpy(optPro.optAlert.smsGateway , "\n");
        if(!chkSMTP->Checked)
        {
                strcpy(optPro.optAlert.smtpUser , "\0");
                strcpy(optPro.optAlert.smtpPassword , "\0");
                strcpy(optPro.optAlert.smtpServer , "\0");
        }

    }
    if(chkFile->Checked)
    {
        optPro.optAlert.bLOG = true;
        strcpy(optPro.optAlert.logFile ,edtLogFile->Text.c_str());
    }
    else
    {
        optPro.optAlert.bLOG = false;
        strcpy(optPro.optAlert.logFile ,"\0");
    }
    IPList->Clear();
    for(int i = 0;i < lstIPList->Items->Count;i++)
                if(lstIPList->Checked[i] == 1)
                        IPList->Add(lstIPList->Items->Strings[i]);
}

void TfrmPreferences::WriteINIFile()
{

        int iFileHandle;
        int iFileLength;
        AnsiString path,fileini,filehost;

        path = GetCurrentDir();
        fileini = path + "\\"+ INIFile;
        filehost = path + "\\" + HOSTFile;
        lstIPList->Items->SaveToFile(filehost);
        for(int i = 0;i < lstIPList->Items->Count;i++)
                if(lstIPList->Checked[i] == 1)
                        optPro.optHost.bitmap[i] = 1;
                else
                        optPro.optHost.bitmap[i] = 0;
        iFileLength = sizeof(optPro);
        iFileHandle = FileCreate(fileini);
        FileWrite(iFileHandle, &optPro, iFileLength);
        FileClose(iFileHandle);
}

void TfrmPreferences::UpdateOptions()
{
    chkAuto->Checked = optPro.optHost.bAutostart;
    edtFreq->Text = IntToStr(optPro.optHost.iInterval);
    if(optPro.optAlert.bSMTP)
    {
        chkSMTP->Checked = true;
        edtUsername->Text = optPro.optAlert.smtpUser;
        edtPassword->Text = optPro.optAlert.smtpPassword;
        edtSMTPServer->Text = optPro.optAlert.smtpServer;
        edtMail->Text = optPro.optAlert.Mail;
    }
    if(optPro.optAlert.bLOG)
    {
        chkFile->Checked = true;
        edtLogFile->Text = optPro.optAlert.logFile;
    }
    if(optPro.optAlert.bSMS)
    {
        if(!optPro.optAlert.bSMTP)
        {
                edtUsername->Text = optPro.optAlert.smtpUser;
                edtPassword->Text = optPro.optAlert.smtpPassword;
                edtSMTPServer->Text = optPro.optAlert.smtpServer;
        }
        chkSMS->Checked = true;
        edtGateway->Text = optPro.optAlert.smsGateway;
    }
}
void __fastcall TfrmPreferences::FormCreate(TObject *Sender)
{
        if(FileExists(GetCurrentDir()+"\\"+INIFile))
        {
                ReadINIFIle();
                UpdateOptions();
                ReadOptions();
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmPreferences::BitBtn2Click(TObject *Sender)
{
        frmPreferences->Close();        
}
//---------------------------------------------------------------------------




void __fastcall TfrmPreferences::chkAutoClick(TObject *Sender)
{
        if(chkAuto->Checked)
                edtFreq->Enabled = true;
        else
                edtFreq->Enabled = false;
}
//---------------------------------------------------------------------------

